<template>
  <Filter @update="search"></Filter>
  <!-- 期货报表 -->
  <mtp-table-scroll>
    <template #default="{ scroll }">
      <a-table :columns="columns" class="srcollYTable" :scroll="scroll" :pagination="false" :expandedRowKeys="expandedRowKeys" :customRow="Rowclick" :rowKey="(record,index)=>index" :data-source="tableList">
        <!-- 持仓方向 -->
        <template #buyorsell="{ record }">
          <a>{{ record.buyorsell === 1 ? '卖出' : '买入' }}</a>
        </template>
      </a-table>
    </template>
  </mtp-table-scroll>
  <!-- 明细 -->
  <mtp-table-detail :columns="columnsDetail" :data-source="detailTableList" :tabs="tabList" v-model:visible="visible" @change="changeTab">
    <!-- 持仓方向 -->
    <template #buyorsell="{ record }">
      <a>{{ record.buyorsell === 1 ? '卖出' : '买入' }}</a>
    </template>
  </mtp-table-detail>
</template>

<script lang="ts">
import MtpTableScroll from '@/common/components/tableScroll/index.vue';
import Filter from '../../components/filterTable/index.vue';
import { defineComponent, queryTableList } from '@/common/export/table';
import { ComposeTableDetailParam, handleComposeTable_detail } from '@/common/setup/table/compose';
import { ref, watch } from 'vue';
import { queryResultLoadingAndInfo } from '@/common/methods/request/resultInfo';
import { handleInitTypeAndTime } from '@/views/report/setup';
import { qryTaFutureDataReport } from '@/services/go/ermcp/report';
import { Ermcp3TaFutuReDataReport, QryTaFutureDataReportReq } from '@/services/go/ermcp/report/interface';
import { TypeAndTime } from '@/views/report/interface';
import { EnumRouterName } from '@/common/constants/enumRouterName';
import { getTableButton } from '@/common/setup/table/button';
import MtpTableDetail from '@/common/components/tableDetail/index.vue';

export default defineComponent({
  name: 'inventory_report_inventory_category',
  components: {
    MtpTableScroll,
    MtpTableDetail,
    Filter,
  },
  setup() {
    let cycletime = '';
    // 表格列表数据
    const { loading, tableList, queryTable } = queryTableList<Ermcp3TaFutuReDataReport>();
    // 控制明细显示/隐藏
    const visible = ref(true);
    // 获取列表数据
    const queryTableAction = () => {
      const { getInitTime, getInitType } = handleInitTypeAndTime();
      cycletime = getInitTime();
      const param: QryTaFutureDataReportReq = {
        cycletype: getInitType(),
        cycletime,
        querytype: 1,
      };
      // 获取列表数据
      queryTable(qryTaFutureDataReport, param).then((res) => {
        if (res.length) {
          selectedRow.value = res[0];
        }
      });
    };
    const param: ComposeTableDetailParam = {
      queryFn: queryTableAction, // 查询表格数据
      tableName: 'table_pcweb_futures_report', // 表头key
      menuType: EnumRouterName.future_report_future, // 当前tab页对应的code
    };
    const {
      columns,
      updateColumn, //  表头数据
      columnsDetail,
      registerColumnDetail,
      detailTableList, // 明细表头数据
      expandedRowKeys,
      selectedRow,
      Rowclick, // 表格事件
    } = handleComposeTable_detail<Ermcp3TaFutuReDataReport>(param);
    const chaceSearchValue = ref<TypeAndTime>();

    // 底部明细标签
    const tabList = getTableButton();
    // 当前选中的标签
    const tabIndex = ref(0);

    // 切换明细
    function changeTab(index: number) {
      tabIndex.value = index;
      const { code, lable } = tabList[index];
      const data = selectedRow.value as Ermcp3TaFutuReDataReport;
      const { cycletype, currencyid, goodsgroupid, goodsid, buyorsell } = data;
      const param: QryTaFutureDataReportReq = {
        querytype: 2,
        cycletype,
        cycletime,
        currencyid,
        goodsgroupid,
        goodsid,
        buyorsell,
        userid: chaceSearchValue.value?.userid,
      };
      if (code === 'future_report_future_detail') {
        // 账户明细
        // 注册表头
        registerColumnDetail('table_pcweb_futures_statement_account_details');
      } else {
        console.error(`${lable}没有配置对应的code: ${code},`);
        return;
      }
      // 查询明细数据
      queryResultLoadingAndInfo(qryTaFutureDataReport, loading, param).then((res) => {
        detailTableList.value = res;
      });
    }

    function search(value: TypeAndTime) {
      detailTableList.value = [];
      chaceSearchValue.value = value;
      cycletime = value.cycletime;
      const obj = Object.assign(value, { querytype: 1 });
      queryTable(qryTaFutureDataReport, obj).then((res) => {
        if (res.length) {
          selectedRow.value = res[0];
        }
      });
    }

    watch(selectedRow, () => {
      detailTableList.value = [];
      if (tabList.length) {
        visible.value = true;
        changeTab(tabIndex.value);
      }
    })

    return { loading, tableList, visible, columns, updateColumn, search, columnsDetail, detailTableList, expandedRowKeys, selectedRow, Rowclick, tabList, changeTab };
  },
});
</script>